//H8/3069F̂߂̃VAʐMCu
//          HRSLIB.H by I.N.

//CPU : H8-3069F,=25.0MHz,sizeof(int)=32
//COM : BaudRate=38400[bps], StartBit=1, StopBit=1, No-parity
//Compiler : YellowIDE 6.5

//2007/02/27 ver.0.1 Jn
//2007/02/28 ver.1.0 
//2008/10/06         Mobt@dl̐Jn
//2008/10/07 ver.2.0 MOobt@dlƂ
//2011/06/15 ver.2.1 MOobt@̉ HRS_Send()

//--------荞݃xN^̓o^--------
//xN^ԍ@o^֐@
//        52  HRS_eri0    b
//        53  HRS_rxi0    b
//        54  HRS_txi0    b
//        56  HRS_eri1    b
//        57  HRS_rxi1    b
//        58  HRS_txi1    b
//        60  HRS_eri2    b
//        61  HRS_rxi2    b
//        62  HRS_txi2    b
//------------------------------------
// ȉ̃IvVɃ`FbN
//  /p@oElĉ\Ȍl߂Ĕzu
//  /b@rbgtB[hʃrbg犄t
//------------------------------------

#ifndef HRSLIB_H
#define HRSLIB_H

#include <sysio.h>

//|[g
#define HRS_COMNUM 3

//Mobt@̃TCY[byte]
#ifndef HRS_RECVBUFFERSIZE0
	#define HRS_RECVBUFFERSIZE0 32
#endif
#ifndef HRS_SENDBUFFERSIZE0
	#define HRS_SENDBUFFERSIZE0 32
#endif
#ifndef HRS_RECVBUFFERSIZE1
	#define HRS_RECVBUFFERSIZE1 32
#endif
#ifndef HRS_SENDBUFFERSIZE1
	#define HRS_SENDBUFFERSIZE1 32
#endif
#ifndef HRS_RECVBUFFERSIZE2
	#define HRS_RECVBUFFERSIZE2 32
#endif
#ifndef HRS_SENDBUFFERSIZE2
	#define HRS_SENDBUFFERSIZE2 32
#endif

//{[[g
//  6 => 111607.1[bps](115200ɑ΂-3.12%) =25.0[MHz]
// 12 =>  60096.2[bps]( 57600ɑ΂+4.33%) =25.0[MHz]
// 13 =>  55803.6[bps]( 57600ɑ΂-3.12%) =25.0[MHz]
// 19 =>  39062.5[bps]( 38400ɑ΂+1.73%) =25.0[MHz]
// 40 =>  19054.9[bps]( 19200ɑ΂-0.76%) =25.0[MHz]
// 80 =>   9645.1[bps](  9600ɑ΂+0.47%) =25.0[MHz]
#ifndef HRS_BRR0
	#define HRS_BRR0	19
#endif
#ifndef HRS_BRR1
	#define HRS_BRR1	19
#endif
#ifndef HRS_BRR2
	#define HRS_BRR2	19
#endif

// --- Mobt@ ---
unsigned char HRS_rbuffer0[HRS_RECVBUFFERSIZE0];
unsigned char HRS_rbuffer1[HRS_RECVBUFFERSIZE1];
unsigned char HRS_rbuffer2[HRS_RECVBUFFERSIZE2];
volatile unsigned char *HRS_rbuffer[HRS_COMNUM]={HRS_rbuffer0,HRS_rbuffer1,HRS_rbuffer2};
const int HRS_rbuffersize[HRS_COMNUM]={HRS_RECVBUFFERSIZE0,HRS_RECVBUFFERSIZE1,HRS_RECVBUFFERSIZE2};
// HRS_recv_wptrn ͎ɏރf[^ʒuw
volatile int HRS_recv_wptr[HRS_COMNUM];
// HRS_recv_rptrn==-1̂Ƃ̓f[^ȂCȊO͎ɓǂނׂf[^ʒuw
volatile int HRS_recv_rptr[HRS_COMNUM];

// --- Mobt@ ---
unsigned char HRS_sbuffer0[HRS_SENDBUFFERSIZE0];
unsigned char HRS_sbuffer1[HRS_SENDBUFFERSIZE1];
unsigned char HRS_sbuffer2[HRS_SENDBUFFERSIZE2];
volatile unsigned char *HRS_sbuffer[HRS_COMNUM]={HRS_sbuffer0,HRS_sbuffer1,HRS_sbuffer2};
const int HRS_sbuffersize[HRS_COMNUM]={HRS_SENDBUFFERSIZE0,HRS_SENDBUFFERSIZE1,HRS_SENDBUFFERSIZE2};
// HRS_send_wptrn ͎ɏރf[^ʒuw
volatile int HRS_send_wptr[HRS_COMNUM];
// HRS_send_rptrn==-1̂Ƃ̓f[^ȂCȊO͎ɓǂނׂf[^ʒuw
volatile int HRS_send_rptr[HRS_COMNUM];

char HRS_openflag[HRS_COMNUM]={0,0,0};

//M(RXI0)ŌĂяo
void interrupt HRS_rxi0(void)
{
	unsigned char c;

	//G[(ORER,ERS,PER)΃NA
	do{
		if(SCI0.SSR.BYTE & 0x38){
			SCI0.SSR.BYTE &= ~0x38;
		}
	}while(!(SCI0.SSR.BYTE & 0x40));
	c=SCI0.RDR;
	SCI0.SSR.BYTE &= ~0x40;

	//buffer full
	if (HRS_recv_wptr[0] == HRS_recv_rptr[0]) return;
	HRS_rbuffer[0][HRS_recv_wptr[0]]=c;
	if (HRS_recv_rptr[0]<0) HRS_recv_rptr[0]=HRS_recv_wptr[0];
	if (++HRS_recv_wptr[0] == HRS_rbuffersize[0]) HRS_recv_wptr[0]=0;
}

//M(RXI1)ŌĂяo
void interrupt HRS_rxi1(void)
{
	unsigned char c;

	//G[(ORER,ERS,PER)΃NA
	do{
		if(SCI1.SSR.BYTE & 0x38){
			SCI1.SSR.BYTE &= ~0x38;
		}
	}while(!(SCI1.SSR.BYTE & 0x40));
	c=SCI1.RDR;
	SCI1.SSR.BYTE &= ~0x40;

	//buffer full
	if (HRS_recv_wptr[1] == HRS_recv_rptr[1]) return;
	HRS_rbuffer[1][HRS_recv_wptr[1]]=c;
	if (HRS_recv_rptr[1]<0) HRS_recv_rptr[1]=HRS_recv_wptr[1];
	if (++HRS_recv_wptr[1] == HRS_rbuffersize[1]) HRS_recv_wptr[1]=0;
}

//M(RXI2)ŌĂяo
void interrupt HRS_rxi2(void)
{
	unsigned char c;

	//G[(ORER,ERS,PER)΃NA
	do{
		if(SCI2.SSR.BYTE & 0x38){
			SCI2.SSR.BYTE &= ~0x38;
		}
	}while(!(SCI2.SSR.BYTE & 0x40));
	c=SCI2.RDR;
	SCI2.SSR.BYTE &= ~0x40;

	//buffer full
	if (HRS_recv_wptr[2] == HRS_recv_rptr[2]) return;
	HRS_rbuffer[2][HRS_recv_wptr[2]]=c;
	if (HRS_recv_rptr[2]<0) HRS_recv_rptr[2]=HRS_recv_wptr[2];
	if (++HRS_recv_wptr[2] == HRS_rbuffersize[2]) HRS_recv_wptr[2]=0;
}

//M(ERI0)ŌĂяo
void interrupt HRS_eri0(void)
{
	//G[΃NA
	if(SCI0.SSR.BYTE & 0x38){
		SCI0.SSR.BYTE &= ~0x38;
	}
}

//M(ERI1)ŌĂяo
void interrupt HRS_eri1(void)
{
	//G[΃NA
	if(SCI1.SSR.BYTE & 0x38){
		SCI1.SSR.BYTE &= ~0x38;
	}
}

//M(ERI2)ŌĂяo
void interrupt HRS_eri2(void)
{
	//G[΃NA
	if(SCI2.SSR.BYTE & 0x38){
		SCI2.SSR.BYTE &= ~0x38;
	}
}

//M(TXI0)ŌĂяo
void interrupt HRS_txi0(void)
{
	int rp;
		
	rp=HRS_send_rptr[0];
	if(rp<0){
		SCI0.SCR.BIT.TIE=0;
		return;
	}

	while(!(SCI0.SSR.BIT.TDRE));
	SCI0.TDR=HRS_sbuffer[0][rp++];
	SCI0.SSR.BIT.TDRE=0;

	if(rp==HRS_sbuffersize[0]) rp=0;
	if(rp==HRS_send_wptr[0]) rp=-1;
	HRS_send_rptr[0]=rp;
}

//M(TXI1)ŌĂяo
void interrupt HRS_txi1(void)
{
	int rp;
		
	rp=HRS_send_rptr[1];
	if(rp<0){
		SCI1.SCR.BIT.TIE=0;
		return;
	}

	while(!(SCI1.SSR.BIT.TDRE));
	SCI1.TDR=HRS_sbuffer[1][rp++];
	SCI1.SSR.BIT.TDRE=0;

	if(rp==HRS_sbuffersize[1]) rp=0;
	if(rp==HRS_send_wptr[1]) rp=-1;
	HRS_send_rptr[1]=rp;
}

//M(TXI2)ŌĂяo
void interrupt HRS_txi2(void)
{
	int rp;
		
	rp=HRS_send_rptr[2];
	if(rp<0){
		SCI2.SCR.BIT.TIE=0;
		return;
	}

	while(!(SCI2.SSR.BIT.TDRE));
	SCI2.TDR=HRS_sbuffer[2][rp++];
	SCI2.SSR.BIT.TDRE=0;

	if(rp==HRS_sbuffersize[2]) rp=0;
	if(rp==HRS_send_wptr[2]) rp=-1;
	HRS_send_rptr[2]=rp;
}

// |[g̃I[v
int HRS_Open(int ncom)
{
	int i;
	if(HRS_openflag[ncom]) return 1;
	_di();
	switch(ncom){
		case 0:
			SCI0.SCR.BYTE = 0x00;		// TE/RE CLEAR
			SCI0.SMR.BYTE = 0x00;		// ASYNC 8 BIT, NON PARITY, 1 STOP BIT
			SCI0.BRR = HRS_BRR0;	// Baudrate
			for(i=0;;i++)if(i==130) break;
			SCI0.SCR.BYTE = 0x70;		// TIE=0,TE=1,TR=1,RIE=1
			break;
		case 1:
			SCI1.SCR.BYTE = 0x00;		// TE/RE CLEAR
			SCI1.SMR.BYTE = 0x00;		// ASYNC 8 BIT, NON PARITY, 1 STOP BIT
			SCI1.BRR = HRS_BRR1;	// Baudrate
			for(i=0;;i++)if(i==130)break;
			SCI1.SCR.BYTE = 0x70;		// TIE=0,TE=1,TR=1,RIE=1
			break;
		case 2:
			SCI2.SCR.BYTE = 0x00;		// TE/RE CLEAR
			SCI2.SMR.BYTE = 0x00;		// ASYNC 8 BIT, NON PARITY, 1 STOP BIT
			SCI2.BRR = HRS_BRR2;	// Baudrate
			for(i=0;;i++)if(i==130)break;
			SCI2.SCR.BYTE = 0x70;		// TIE=0,TE=1,TR=1,RIE=1
			break;
	}
	HRS_recv_wptr[ncom]=0;
	HRS_recv_rptr[ncom]=-1;
	HRS_send_wptr[ncom]=0;
	HRS_send_rptr[ncom]=-1;
	HRS_openflag[ncom]=1;
	_ei();
	return 0;
}

// |[g̃N[Y
int HRS_Close(int ncom)
{
	if(!HRS_openflag[ncom]) return 1;
	switch(ncom){
		// clear TIE,RIE,TE,RE,MPIE,TEIE
		case 0: SCI0.SCR.BYTE=0x00; break;
		case 1: SCI1.SCR.BYTE=0x00; break;
		case 2:	SCI2.SCR.BYTE=0x00; break;
	}
	HRS_openflag[ncom]=0;
	return 0;
}

// f[^̎M
int HRS_Recv(int ncom, unsigned char *buf, int n)
{
	int i,rp;
	
	if(!HRS_openflag[ncom]) return 0;

	if(n>HRS_rbuffersize[ncom]) n=HRS_rbuffersize[ncom];
	
	for(i=0;i<n;i++){
		rp=HRS_recv_rptr[ncom];
		if (rp<0) break;

		*buf++ = HRS_rbuffer[ncom][rp++];

		if(rp==HRS_rbuffersize[ncom]) rp=0;
		if(rp==HRS_recv_wptr[ncom]) rp=-1;
		HRS_recv_rptr[ncom]=rp;
	}
	return i;
}

// Mobt@̃`FbN
// (obt@Ɋi[ς݂̃f[^oCgPʂŕԂ)
int HRS_CheckRecv(int ncom)
{
	int rp,wp;
	
	if(!HRS_openflag[ncom]) return 0;

	rp=HRS_recv_rptr[ncom];
	wp=HRS_recv_wptr[ncom];

	if (rp<0) return 0;

	if (wp>rp){
		return wp-rp;
	}else{
		return HRS_rbuffersize[ncom]-(rp-wp);
	}
}

// Mobt@̃`FbN
// (obt@̋󂫂oCgPʂŕԂ)
int HRS_CheckSend(int ncom)
{
	int rp,wp;
	
	if(!HRS_openflag[ncom]) return 0;

	wp=HRS_send_wptr[ncom];
	rp=HRS_send_rptr[ncom];

	if (rp<0) return HRS_sbuffersize[ncom];

	if (wp>rp){
		return HRS_sbuffersize[ncom]-(wp-rp);
	}else{
		return (rp-wp);
	}
}

// Mobt@̃NA
int HRS_ClearRecv(int ncom)
{
	if(!HRS_openflag[ncom]) return 1;
	HRS_recv_rptr[ncom]=-1;
	return 0;
}

// Mobt@̃NA
int HRS_ClearSend(int ncom)
{
	if(!HRS_openflag[ncom]) return 1;
	switch(ncom){
		case 0: SCI0.SCR.BIT.TIE=0; break;
		case 1: SCI1.SCR.BIT.TIE=0; break;
		case 2: SCI2.SCR.BIT.TIE=0; break;
	}
	HRS_send_rptr[ncom]=-1;
	return 0;
}

// P̎M
int HRS_Getc(int ncom)
{
	unsigned char c;
	if(!HRS_openflag[ncom]) return -1;
	if(!HRS_Recv(ncom,&c,1)) return -1;
	return c;
}

// (Ōオ\n/\r/0̂ꂩ)̎M
int HRS_Gets(int ncom, unsigned char *s)
{
	int n=0;
	if(!HRS_openflag[ncom]) return n;

	for(;;){
		if (HRS_Recv(ncom,s,1)==1) {
			if(*s=='\n' || *s=='\r' || *s==0){
				*s=0;
				n++;
				break;
			}else{
				s++;
				n++;
			}
		}
	}
	return n;
}

// f[^̑M
// (f[^͑Mobt@֊i[)
// sh7125rslib 2.2Ɠl̏C 2011.6.15
int HRS_Send(int ncom, char *buf, int n)
{
	int i,wp;
	
	if(!HRS_openflag[ncom]) return 0;

	for(i=0;i<n;i++){
		wp=HRS_send_wptr[ncom];
		if (wp == HRS_send_rptr[ncom]) return i;	//buffer full

		HRS_sbuffer[ncom][wp]=*buf++;
		
		if ((wp+1) == HRS_sbuffersize[ncom]) HRS_send_wptr[ncom]=0;
		else HRS_send_wptr[ncom]++;

		if (HRS_send_rptr[ncom]<0) HRS_send_rptr[ncom]=wp;

		switch(ncom){
			case 0:	SCI0.SCR.BIT.TIE=1; break;
			case 1:	SCI1.SCR.BIT.TIE=1; break;
			case 2:	SCI2.SCR.BIT.TIE=1; break;
		}
	}
	return n;
}

// P̑M
int HRS_Putc(int ncom, unsigned char c)
{
	if(!HRS_openflag[ncom]) return 0;
	return HRS_Send(ncom,&c,1);
}

// ̑MiŌ\nj
int HRS_Puts(int ncom, unsigned char *s)
{
	int n=0;
	if(!HRS_openflag[ncom]) return n;
	while(*s){
		HRS_Putc(ncom,*s++);
		n++;
	}
	HRS_Putc(ncom,'\n');
	n++;
	return n;
}

// ̑MiŌɉȂj
int HRS_Sends(int ncom, unsigned char *s)
{
	int n=0;

	if(!HRS_openflag[ncom]) return 0;
	while(*s){
		HRS_Putc(ncom, *s++);
		n++;
	}
	return n;
}

//HRS_Printf()֐g
//st@C̃TCY12KBقǑ傫ȂD
#include <stdio.h>
#ifndef HRS_PRINTF_BUFFERSIZE
	#define HRS_PRINTF_BUFFERSIZE	256
#endif
int HRS_Printf(int ncom, char *format, ...)
{
	va_list vl;
	char buf[HRS_PRINTF_BUFFERSIZE];

	va_start(vl,format);
	vsprintf(buf,format,vl);

	return HRS_Puts(ncom,buf);
}

#endif
